'' SERVO AND MORE: SAM SIDPLAYER PROJECT
'' BY JEFF LEDGER AKA OLDBITCOLLECTOR

CON
 
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
    playRate = 50'Hz       

  spiDO     = 6
  spiClk    = 7
  spiDI     = 8
  spiCS     = 9

  '' SIDcog audio outputs on 16,19 per the project instructions.
  '' Please DMP files into a DMP folder on your SD card.
  
OBJ

  SD  : "KYEFAT"               
  SID : "SIDCog"
  
DAT
  folder byte "dmp",0          '<-- Folder location of your DMP files
  
VAR

  byte sidbuffer[25]
  long waitTime
  byte fileNumber
  
PUB main  | volume , n
                        
  SID.start  
   ifnot( sd.FATEngineStart(spiDO, spiClk, spiDI, spiCS, -1, -1 , -1, -1, -1))                                   
      abort
  volume:=2  'inital volume
  fileNumber := 1
  sd.mountPartition(0)
  sd.changeDirectory(@folder)
      
  fileNumber++
  openNextFile
  
  outa[0..3]   := %1111                                               

  repeat

     n := GetButtons 'Grab only 0..3 button data. returns 241,242,244,248

    '' Volume Adjust
    if n == 241  ' Touch button 5 from the left [* * * * X * * *]
       volume++
       
    '' Skip to next song
    if n == 244  ' Touch button 7 from the left [* * * * * * X *]
    
        bytefill(@sidbuffer,0,25)
        SID.updateRegisters(@sidbuffer)
        fileNumber++
        openNextFile
      
    waitcnt(cnt + (clkfreq/playRate))      ' Wait one VBL
    ifnot( sd.readdata(@sidbuffer, 25) )
        bytefill(@sidbuffer,0,25)
        SID.updateRegisters(@sidbuffer)
        fileNumber++
        openNextFile

    sidbuffer[24]:= (sidbuffer[24]&$F0) | (volume&$0F)
    sid.updateRegisters(@sidbuffer)       
  

PUB openNextFile | i,data

    sd.listEntries("W")
    repeat fileNumber
         data := sd.listEntries("N")
                 
    data := sd.listEntries("N")
    trimString(data)

    sd.openfile( data, "r")           


PUB trimString(characters)

  result := ignoreSpace(characters)
  characters := (result + ((strsize(result) - 1) #> 0))

  repeat
    case byte[characters]
      8 .. 13, 32, 127: byte[characters--] := 0
      other: quit
      
PRI ignoreSpace(characters) ' 4 Stack Longs

  result := characters
  repeat strsize(characters--)
    case byte[++characters]
      8 .. 13, 32, 127:
      other: return characters

      
PUB getButtons : state              ''read buttons and return states

  dira[0..3]~~                      'switch button pins to High
  dira[0..3]~                       'and then back to inputs
  waitcnt(160_000+cnt)              'wait 2ms
  return ina[0..3] ^ $FF            'read button inputs (pressed=1)

  